> ## Documentation Index
> Fetch the complete documentation index at: https://docs.dune.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Search Datasets by Contract Address

> Find decoded datasets associated with a smart contract address

<Info>
  Minimum required API key scope: `Read`
</Info>

# Use Cases

* **Contract Analysis**: Find all decoded datasets associated with a specific smart contract address.
* **Blockchain Filtering**: Narrow results to decoded tables on specific blockchains using the `blockchains` parameter.
* **Build Contract Explorers**: Power contract exploration tools that surface relevant decoded tables for any contract address.
* **Data Integration**: Programmatically discover decoded event and function tables for a contract to build ETL pipelines.
* **Schema Discovery**: Retrieve the schema of decoded tables for a contract by setting `include_schema` to `true`.


## OpenAPI

````yaml POST /v1/datasets/search-by-contract
openapi: 3.0.1
info:
  contact: {}
  description: Dune API
  title: DuneAPI
  version: '1.0'
servers:
  - url: https://api.dune.com/api
security: []
paths:
  /v1/datasets/search-by-contract:
    post:
      summary: Search datasets by contract address
      description: Find decoded datasets associated with a smart contract address
      parameters:
        - description: API Key for the service
          in: header
          name: X-Dune-Api-Key
          required: true
          schema:
            type: string
        - description: API Key, alternative to using the HTTP header X-Dune-Api-Key
          in: query
          name: api_key
          schema:
            type: string
      requestBody:
        content:
          application/json:
            schema:
              $ref: >-
                #/components/schemas/models.SearchDatasetsByContractAddressRequest
        description: Search by contract address request
        required: true
        x-originalParamName: body
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/models.SearchDatasetsResponse'
          description: OK
        '400':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/models.Error400'
          description: Bad Request
        '401':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/models.Error401'
          description: Unauthorized
        '403':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/models.Error403'
          description: Forbidden
        '500':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/models.Error500'
          description: Internal Server Error
components:
  schemas:
    models.SearchDatasetsByContractAddressRequest:
      properties:
        blockchains:
          items:
            type: string
          type: array
        contract_address:
          type: string
        include_schema:
          type: boolean
        limit:
          type: integer
        offset:
          type: integer
      required:
        - contract_address
      type: object
    models.SearchDatasetsResponse:
      properties:
        pagination:
          $ref: '#/components/schemas/models.SearchDatasetsPagination'
        results:
          items:
            $ref: '#/components/schemas/models.SearchDatasetResult'
          type: array
        total:
          type: integer
      type: object
    models.Error400:
      properties:
        error:
          example: Bad Request
          type: string
      type: object
    models.Error401:
      properties:
        error:
          example: Invalid API Key
          type: string
      type: object
    models.Error403:
      properties:
        error:
          example: >-
            Not allowed to execute query. Query is archived, unsaved or not
            enough permissions
          type: string
      type: object
    models.Error500:
      properties:
        error:
          example: Internal error
          type: string
      type: object
    models.SearchDatasetsPagination:
      properties:
        has_more:
          type: boolean
        limit:
          type: integer
        next_offset:
          type: integer
        offset:
          type: integer
      type: object
    models.SearchDatasetResult:
      properties:
        blockchains:
          items:
            type: string
          type: array
        category:
          type: string
        dataset_type:
          type: string
        description:
          type: string
        full_name:
          type: string
        metadata:
          $ref: '#/components/schemas/models.SearchDatasetMetadata'
        owner_scope:
          type: string
        schema:
          items:
            type: integer
          type: array
        visibility:
          type: string
      type: object
    models.SearchDatasetMetadata:
      properties:
        abi_type:
          type: string
        contract_name:
          type: string
        description:
          type: string
        page_rank_score:
          type: number
        project_name:
          type: string
        spell_metadata:
          items:
            type: integer
          type: array
        spell_type:
          type: string
      type: object

````